#include "../defs.h"
#include "../Lock/lock.h"
#include "../mountrec.h"
#include "catrectable.h"
#include <stdlib.h>

CATALOG_RECORD oct[MAXOPENCATRECS];

int initopencatrectable()
{
  int i;

  for (i=0; i<MAXOPENCATRECS; i++) {
    oct[i].cdrType=0xff;
    oct[i].locked=make_lock();
  }

  return 0;
}


CATALOG_RECORD *allocopencatrec()
{
  int i;
  
  for (i=0; (i<MAXOPENCATRECS); i++) {
    lock(oct[i].locked);
    if (oct[i].cdrType==0xff) {
      oct[i].cdrType=0xee;
      oct[i].status=0;
      oct[i].refcount=0;
      unlock(oct[i].locked);
      return &(oct[i]);
    }
    unlock(oct[i].locked);
  }
  
  return NULL;
  
}



int deallocopencatrec(CATALOG_RECORD *cr)
{
  cr->cdrType=0xff;
  return 0;
}


int setstatusofmatchingopencatrecs(CATALOG_RECORD *cr, int status)
{
  LONGWORD id;
  int i;

  switch (cr->cdrType) {
  case CDR_DIR:
    id=cr->U.cdrDirRec.dirDirID;
    break;
  case CDR_FILE: 
    id=cr->U.cdrFilRec.filFlNum;
    break;

  case CDR_DTHREAD: 
  case CDR_FTHREAD: 

/* Shouldn't be on the open catrectable */

  default:
    return 0;
  }

  for (i=0;i<MAXOPENCATRECS; i++) {
    lock(oct[i].locked);
    switch (oct[i].cdrType) {
    case CDR_DIR: 
      if (oct[i].U.cdrDirRec.dirDirID==id) 
	oct[i].status=status;
      break;
    case CDR_FILE: 
      if (oct[i].U.cdrFilRec.filFlNum==id) 
	oct[i].status=status;
      break;
    case CDR_DTHREAD: 
    case CDR_FTHREAD: 

/* Shouldn't be on the open catrectable */

    default:
      break;
    }
    unlock(oct[i].locked);
  }

  return 0;

}


CATALOG_RECORD *findidoncatrectable(CATALOG_RECORD *cr)
{
  LONGWORD id;
  int i;

  switch (cr->cdrType) {
  case CDR_DIR:
    id=cr->U.cdrDirRec.dirDirID;
    break;
  case CDR_FILE: 
    id=cr->U.cdrFilRec.filFlNum;
    break;
  case CDR_DTHREAD: 
  case CDR_FTHREAD: 
/* Shouldn't be on the open catrectable */
  default:
    return NULL;
  }
  
  for (i=0;i<MAXOPENCATRECS; i++) {
    lock(oct[i].locked);
    switch (oct[i].cdrType) {
    case CDR_DIR: 
      if (oct[i].U.cdrDirRec.dirDirID==id) {
	unlock(oct[i].locked);
	return(&(oct[i]));
      }
      break;
    case CDR_FILE: 
      if (oct[i].U.cdrFilRec.filFlNum==id) {
	unlock(oct[i].locked);
	return(&(oct[i]));
      }
      break;
    case CDR_DTHREAD: 
    case CDR_FTHREAD: 
/* Shouldn't be on the open catrectable */
    default:
      break;
    }
    unlock(oct[i].locked);
  }
  return NULL;
}















