#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/uio.h>
#include <sys/file.h>
#include <stdlib.h>
#include <sysent.h>
#include <errno.h>
#include <sys/stat.h>
#include <strings.h>


struct timeval tv;

void start_timing()
{
    gettimeofday(&tv, NULL);
}

double end_timing()
{
    struct timeval tv2;
    gettimeofday(&tv2, NULL);
    return(tv2.tv_sec - tv.tv_sec
	   + 1.e-6 * (tv2.tv_usec - tv.tv_usec));
}




#define BLOCKSIZ 100000



/*
#define NUM_TIMES 1000
#define READ_TIMES 10000
*/
#define NUM_TIMES 100
#define READ_TIMES 1000

#define TEST_FILE_CREATE_DELETE 1
#define TEST_COCD 0
#define TEST_WRITE 0
#define TEST_READ 0

int main(int argc, char *argv[])
{
  int fd;
    int i;
    int c1;
    char name[256] = "nullfile";
    int start,end;
    double TIME;

    
#if TEST_FILE_CREATE_DELETE
    start_timing();
    for(i=1;i<=1000;i++){
      sprintf(name,"test%d",i);
      if ((fd=creat(name, 0666))<0){
	printf("Can't Create %s\n",name);
	exit(0);
      }
      close(fd);
    }
    TIME=end_timing();
    printf("time to create/close %d files = %f sec = %f files/sec\n",
	   i-1,TIME, (float) ((double)i-1)/TIME);
      
    start_timing();
    for(i=1;i<=1000;i++){
      sprintf(name,"test%d",i);
      
      if (unlink(name)){
	printf("Can't delete %s\n",name);
	exit(0);
      }
    }
    TIME = end_timing();
    printf("time to delete %d files = %f sec = %f files/sec\n",
	   i-1,TIME, (float) ((double)i-1)/TIME);

#endif

#if TEST_COCD
    start_timing();
    for(c1=1;c1<=1000;c1++){
      if ((fd=creat(name,0666))<0){
	printf("Iteration %d of c/o/c/d: Can't Create %s\n",c1,name);
	exit(0);
      }
      close(fd);
      
      if (unlink(name)){
	printf("Iteration %d of c/o/c/d: Can't delete %s\n",c1,name);
	exit(0);
      }
    }
    TIME=end_timing();

    printf("time to create/close/delete %d files = %f\n",
	   NUM_TIMES,TIME);
#endif

#if TEST_WRITE    
#if 0
    for(i=100;i<=1000;i*=10){
	for(j=1000;(j<=10000)&&(j<=(i*100));j*= 10){
#else
    for(i=1000;i<1001;i++) { for(j=1000;j<1001;j++) {
#endif
	    if ((fd=creat(name,0666))<0){
		printf("Iter %d of write: Can't Create %s\n",c1,name);
		exit(0);
	    }
	    start=time(0);
	    for(c1=1;c1<=NUM_TIMES;c1++){
		c3=(100*i)/j;
		for(c2=0;c2<c3;c2++){
		    if (write(fd,buf,j)<0){
			printf("Iter %d write failed\n", c1);
			exit(0);
		    }
		}
		if(lseek(fd, 0, L_SET) != 0)
		{
		    printf("Iter %d seekback failed\n", c1);
		    exit(0);
		}
	    }
	    end=time(0);
	    close(fd);
	    if (unlink(name)){
		printf("Iter %d of write: Can't delete %s\n",c1,name);
		exit(0);
	    }   
	    TIME = end-start;
/*	    TIME = (TIME>base)?(TIME-base):1;*/
	    printf("time to write %d %08d byte files (block size = %08d) = %08d = %011f bytes/sec\n",
		   NUM_TIMES,i*100,j,TIME,(i*100*NUM_TIMES)/(double)(TIME));
	}
    }
#endif

#if TEST_READ
    strcpy(name,"testfile");
    start=time(0);
    
    for(c1=1;c1<=READ_TIMES;c1++){

	if ((fd=creat(name,0666))<0){
	    printf("Can't Create %s\n",name);
	    exit(0);
	}
	close(fd);

    }
    end=time(0);
    base=end-start;

	if (unlink(name)){
	    printf("Can't delete %s\n",name);
	    exit(0);
	}
    printf("time to create/close/delete %d files = %d\n",
	   READ_TIMES,base);
        
    for(i=100;i<=1000;i*=10){
	for(j=1000;(j<=10000)&&(j<=(i*100));j*= 10){

	    if ((fd=creat(name,0666))<0){
		printf("Can't Create %s\n",name);
		exit(0);
	    }
	    
	    c3=(100*i)/1000;
	    for(c2=0;c2<c3;c2++){
		if (write(fd,buf,j)<0){
		    printf("write failed\n");
		    exit(0);
		}
	    }
	    close(fd);
	    start=time(0);
	    for(c1=1;c1<=READ_TIMES;c1++){
		
		if ((fd=open(name,O_RDONLY,0666))<0){
		    printf("Can't open %s\n",name);
		    exit(0);
		}
		c3=(100*i)/j;
		for(c2=0;c2<c3;c2++){
		    if (read(fd,buf,j)<0){
			printf("read failed\n");
			exit(0);
		    }
		}
		close(fd);
		
	    }
	    end=time(0);
	    TIME = end-start;
	    TIME = (TIME>base)?(TIME-base):1;
	    printf("time to read %d %08d byte files (block size = %08d) = %08d = %011f bytes/sec\n",
		   READ_TIMES,i*100,j,TIME,(i*100*READ_TIMES)/(double)(TIME));
	    
	
	    if (unlink(name)){
		printf("Can't delete %s\n",name);
		exit(0);
	    }
	}
    }
#endif
    exit(0); 
    
}
