#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/uio.h>
#include <sys/file.h>
#include <stdlib.h>
#include <sysent.h>
#include <errno.h>
#include <sys/stat.h>
#include <strings.h>
#include "../Includes/macfs_user.h"

#define BLOCKSIZ 100000



/*
#define NUM_TIMES 1000
#define READ_TIMES 10000
*/
#define NUM_TIMES 100
#define READ_TIMES 1000

#define TEST_FILE_CREATE_DELETE 1
#define TEST_COCD 0
#define TEST_WRITE 0
#define TEST_READ 0


MOUNT_RECORD mr;

struct timeval tv;

void start_timing()
{
    gettimeofday(&tv, NULL);
}

double end_timing()
{
    struct timeval tv2;
    gettimeofday(&tv2, NULL);
    return(tv2.tv_sec - tv.tv_sec
	   + 1.e-6 * (tv2.tv_usec - tv.tv_usec));
}


int main(int argc, char *argv[])
{
    int fd;
    int i,j;
    int c1,c2,c3;
    char buf[BLOCKSIZ];
    char name[256] = "nullfile";
    int start,end;
    int base;
    double TIME;
    int rc;
    MFILE mfile;
    char *devname, *partnum;
    LONGWORD blocksize;
    
    devname=getenv("MACDEVICE");
    partnum=getenv("MACPART");
    
    
    
    if (devname==NULL || partnum==NULL) {
      puts("Please set the environment variables MACDEVICE and MACPART before");
      puts("running any mac utility.  MACDEVICE is like /dev/rz4h or /dev/fd0");
      exit(1);
    }
    
    rc=macmount(devname, atoi(partnum), &mr);
    
    if (rc) {
      puts("macmount failed");
      exit(2);
    }
    
    initopencatrectable();
    
    
    
#if TEST_FILE_CREATE_DELETE
    start_timing();
    for(i=1;i<=1000;i++){
      sprintf(name,":test%d",i);
      if ((rc=maccreatefile(&mr,name,3,&mfile))){
	printf("Can't Create %s - rc=%d\n",name, rc);
	exit(0);
      }
      macclose(&mfile);
    }
    TIME = end_timing();
    printf("time to create/close %d files = %f sec = %f files/sec\n",
	   i-1,TIME,(float) ((double)i-1)/TIME);
    
    start_timing();
    for(i=1;i<=1000;i++){
      sprintf(name,":test%d",i);
      
      if ((rc=macdeletefile(&mr,name))){
	printf("Can't delete %s - rc=%d\n",name,rc);
	exit(0);
      }
    }
    TIME=end_timing();
    printf("time to delete %d files = %f sec = %f files/sec\n",
	   i-1,TIME,(float) ((double)i-1)/TIME);

    
#endif
    
    macunmount(&mr);
    
    exit(0);
}

