#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/file.h>
#include <stdlib.h>
#include <sysent.h>
#include <errno.h>
#include <sys/stat.h>
#include <strings.h>
#include "../defs.h"
#include "../errors.h"
#include "../Lock/lock.h"
#include "../mountrec.h"
#include "../LibFuncs/macmount.h"
#include "../DevSupport/readwrite.h"
#include "../Volume/volinfo.h"
#include "../Volume/volbmap.h"
#include "../LibFuncs/catalog.h"
#include "../LibFuncs/catalog_local.h"
#include "../btree/btree.h"
#include "../LibFuncs/macreadwrite.h"
#include "../LibFuncs/catrectable.h"
#include "../Times/mac_time.h"




MOUNT_RECORD MR;

#define BLOCKSIZ 1000


void print_mac_time(long t)
{
    char buf[27];
    t -= 0x7C25783F;
    sprintf(buf,"%s",ctime(&t));
    buf[24]=0;
    printf(buf);
}

void quit()
{
    macunmount(&MR);
    exit(0);
}


int delete_dir(char *cdloc,char *arg)
{
    struct stat sbuf;
    BYTE dir[256];
    int is_file=1;
    FILE *f;

    
    if(stat(cdloc,&sbuf)== -1){
	if(ENOENT == errno){
	    is_file=0;
	} else {
	    printf("count not stat %s\n",cdloc);
	}
    }

    if(is_file && ((f=fopen(cdloc,"r"))==NULL)){
	    printf("could not open : %s\n",cdloc);
	    quit();
    }

    strcpy(dir,arg);
    if (*(arg)==':') {
	if(macdeletefolder(&MR,arg)){
	    printf("could not delete : %s\n",arg);
	    quit();
	}
    } else {
	if(is_file){
	    fgets(dir,256,f);
	    strcat(dir,":");
	} else {
	    dir[0]=':';
	    dir[1]=NULL;
	}

	strcat(dir,arg);
	if(macdeletefolder(&MR,dir)){
	    printf("could not delete : %s\n",arg);
	    quit();
	}
    }

    if(is_file)fclose(f);
    return 0;
}

int main(int argc, char *argv[])
{
    int fail;
    int b;

    char *devname, *partnum,*cdfileloc;

    devname=getenv("MACDEVICE");
    partnum=getenv("MACPART");
    cdfileloc=getenv("MACCDLOC");

    
    if (devname==NULL || partnum==NULL || cdfileloc==NULL) {
	puts("Please set the environment variables MACDEVICE, MACPART and MACCDLOC before");
	puts("running any mac utility.  MACDEVICE is like /dev/rz4h or /dev/fd0");
	exit(1);
    }
    
    
    if (macmount(devname,atoi(partnum),&MR)) {
	printf("Sorry, couldn't mount %s partition %s\n", devname, partnum );
	exit(1);
    }
    
    initopencatrectable();
    
    fail=0;
    
    b=0;
    delete_dir(cdfileloc,argv[1]);
    

    macunmount(&MR);
    
    exit(0); 
    
}

