/* maybe you don't need all of these but I have no idea */
#include <sys/param.h>
#include <sys/dir.h>
#include <sys/user.h>
#include <sys/buf.h>
#include <sys/inode.h>
#include <sys/systm.h>

struct vnode *devvp;

/*
   Notice all the sophisticated error handling

   I'm don't know what the difference is b/w bread and getblk (maybe
   getblk doesn't actually read the device, just sets up a buf
   structure?).

   I think that you can do bforce(bp) instead of bwrite(bp) for
   a synchronous write.

   There's also a universal constant DEV_BSIZE.  I'm not sure but
   I think all sector_numbers are as positions as multiples of
   DEV_BSIZE, not as multiples of the sector size you pass.  For example
   dosfs has

    /* Read all of the FAT in (MDOS_SECTOR_SIZE = 512 bytes) */
    i = dosfsmp->fat_len * MDOS_SECTOR_SIZE;
    bp = bread (devvp, (dosfsmp->fat_start * MDOS_SECTOR_SIZE) / DEV_BSIZE, i);

    According to comments in <sys/param.h>, there is

    DEV_BSIZE = sector size for *all* blocked devices =  512 or 1024
    BLKDEV_IOSIZE = size blocked devices are actually read in = 2048

    Device drivers "believe" in DEV_BSIZE, ufs believes in BLKDEV_IOSIZE.

*/

int InitReadWriteBuffers(struct vnode *device)
{
    devvp = device;
    return(0);
}

int ReadBuffer(char *buf, int sector_number, int sector_size)
{
    struct buf *bp;
    bp = bread(devvp, sector_number, sector_size);
    if(bp->b_error) return(bp->b_error);
    bcopy(bp->b_un.b_addr, buf, sector_size);
    brelse(bp);
    return(0);
}

int WriteBuffer(char *buf, int sector_number, int sector_size)
{
    bp = getblk(devvp, sector_number, sector_size);
    bcopy(buf, bp->b_un.b_addr, sector_size);
    /* bwrite is synchronous.
       bdwrite marks the block dirty.
       bawrite writes it out to disk asynchronously.
    */
    bdwrite(bp);
    return(0);
}
