/* The organization of the beast:

   memory management:

      We have macfs_nodes.  Each macfs_node starts off with a vnode,
      which allows us to communicate with the vfs layer in vnodes.
      Each file has 1 macfs_node, and we never have more than one
      macfs_node for a file in memory.  All referenced nodes are kept
      in a cache.  Every node has a reference count, a link count (0
      or 1), a lock bit, a wanted bit, a node number, user and group
      owner ids, resident device record, and a catalog record.  We use
      VTO_MAC and MAC_TOV to convert b/w vnode and macfs_node.

      Management routines on macfs_nodes for internal use:

        macfs_dirlook -- reads in a vnode and increment its ref count
        MAC_ILOCK(), MAC_IUNLOCK() to serialize access
        macfs_iupdat -- flush to node's catalog record to disk
        macfs_irelease -- release node, checking that we've no lock

      To make this work, we need these routines:

        macfs_inactive()   Clear out node -- refcount 0.  Called by vfs.
        macfs_init()       Initialize.  Called by vfs.
        macfs_iactive()    Search cache or return new macfs_node.
        macfs_ilock()      Implied by MAC_ILOCK.
        macfs_iunlock()    Implied by MAC_IUNLOCK.
        VN_HOLD(MAC_TOV()) to increment refcount
        VN_RELE(MAC_TOV()) to decrement refcount (release)

      iactive() locks any node it returns; inactive requires that any
      node passed to it not be locked.  Basically, any node passed in
      from vfs will be unlocked with refcount>0 because any node
      passed back to vfs will be unlocked with refcount>0.

      The mount call actually releases the covered vnode on error; the
      unmount call actually releases the covered vnode on success.

      The lookup and create calls will actually convert any device
      vnode they find to a special vnode and release the initial
      vnode.

      The Mac doesn't separate the Catalog record (which connects a
      file to a directory) from the disk allocation information.
      Therefore hard links cannot be supported.  Deleting a file from
      a directory while allowing future I/O on it if already open is
      awkward -- I will pull some hack of renaming the file to an
      illegal name and deleting that file when the file becomes
      inactive.  That requires that a file know its own name and
      parent id (to be capable of renaming and deleting itself), so,
      that's why there's a name and parentid entry in the macf_node.
      Inactive will know to delete the file because its nlinks entry
      will be zero.

*/
